clear
clc
format long
bond_length=[50
60
70
80
90
100
125
150
175
200
225
250
275
300
350
400
450
500
];
FCI_singlet_energy =[-1.10342
-1.15536
-1.17259
-1.17190
-1.16189    
-1.14725
-1.10531
-1.06790
-1.04010
-1.02193
-1.01130
-1.00558
-1.00268
-1.00125
-1.00023
-0.99999
-0.99998
-0.99991
]'
Emin=-1.17387
dmin=74.199
y = transpose(FCI_singlet_energy - Emin)
n=length(y)
p=18
X=zeros(n,p);
% model is
for i=1:n
    for j=1:p
        X(i,j) = (bond_length(i) - dmin)^(j+1)/(bond_length(i)^(j+1) + dmin^(j+1) );
    end
end  
display(X)
'The rank of X is'
rank(X)
%Note that on the following line, the value of lambda is set to the target value of 1e-8, 1e-9, 1e-10, 1e-11, 1e-12, or 1e-20
lambda=1e-20
[beta_matrix_1,FitInfo] = lasso(X,y,'Lambda',lambda,'Intercept',false,'RelTol',1e-9,'MaxIter',1e10)
ypred_1 = X*beta_matrix_1
residual_1 = y - ypred_1
norm(residual_1)
ypred=ypred_1+Emin
%
datapoints=zeros(500,1);
for h=1:500
    distance=h;
    temp=0;
    for j=1:p
        temp = temp + beta_matrix_1(j) * (distance - dmin)^(j+1)/(distance^(j+1) + dmin^(j+1) );
    end
    datapoints(h)=temp;
end
datapoints=datapoints+Emin


