function potential_energy = calc_potential_2stretches(displaced_geom1,kstretch1,kstretch2,kbend,d_eq1,d_eq2,theta_eq,gamma1,gamma2)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
bond_vector_AB = displaced_geom1(1,:) - displaced_geom1(2,:);
bond_vector_CB = displaced_geom1(3,:) - displaced_geom1(2,:);
d1 = norm(bond_vector_AB);
d2 = norm(bond_vector_CB);
stretch_energy_1 = (3*kstretch1/(5*gamma1^2))*(1 - 2.5*exp(-gamma1*(d1 - d_eq1)) + 1.5*exp(-(5/3)*gamma1*(d1 - d_eq1)));
stretch_energy_2 = (3*kstretch2/(5*gamma2^2))*(1 - 2.5*exp(-gamma2*(d2 - d_eq2)) + 1.5*exp(-(5/3)*gamma2*(d2 - d_eq2)));
dot_product = dot(bond_vector_AB,bond_vector_CB)/(d1*d2);
theta = acos(dot_product);
bend_energy = kbend*2*(cos(theta)-cos(theta_eq))^2/(sin(theta)^2+3*(sin(theta_eq)^2)*(tanh(2*sin(theta/2))/tanh(2*sin(theta_eq/2))));
potential_energy = stretch_energy_1 + stretch_energy_2 + bend_energy;
end

